## zydis 4.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9 FATAL_ERROR)

if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.15")
    # Enable runtime library selection via CMAKE_MSVC_RUNTIME_LIBRARY
    cmake_policy(SET CMP0091 NEW)
endif ()

project(Zydis VERSION 4.1.1.0 LANGUAGES C)

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

# Set ZYDIS_ROOT_PROJECT to ON if this is the top-level project otherwise OFF by default.
set(ZYDIS_ROOT_PROJECT OFF)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(ZYDIS_ROOT_PROJECT ON)
endif()

# =============================================================================================== #
# Overridable options                                                                             #
# =============================================================================================== #

# Features
option(ZYDIS_MINIMAL_MODE
    "Enable minimal mode (forces ZYDIS_DECODER_MODE_MINIMAL runtime option)"
    OFF)
option(ZYDIS_FEATURE_DECODER
    "Enable instruction decoding functionality"
    ON)
option(ZYDIS_FEATURE_ENCODER
    "Enable instruction encoding functionality"
    ON)
option(ZYDIS_FEATURE_FORMATTER
    "Enable instruction formatting functionality"
    ON)
option(ZYDIS_FEATURE_AVX512
    "Enable support for AVX-512 instructions"
    ON)
option(ZYDIS_FEATURE_KNC
    "Enable support for KNC instructions"
    ON)
option(ZYDIS_FEATURE_SEGMENT
    "Enable instruction segment API"
    ON)

# Build configuration
option(ZYDIS_BUILD_SHARED_LIB
    "Build shared library"
    OFF)
option(ZYDIS_BUILD_EXAMPLES
    "Build examples"
    ${ZYDIS_ROOT_PROJECT})
option(ZYDIS_BUILD_TOOLS
    "Build tools"
    ${ZYDIS_ROOT_PROJECT})
option(ZYDIS_BUILD_MAN
    "Build manpages for the tools (requires Ronn-NG)"
    OFF)
option(ZYDIS_BUILD_DOXYGEN
    "Build doxygen documentation (requires Doxygen)"
    ${ZYDIS_ROOT_PROJECT})
option(ZYDIS_BUILD_TESTS
    "Build tests"
    ${ZYDIS_ROOT_PROJECT})
option(ZYDIS_FUZZ_AFL_FAST
    "Enables AFL persistent mode and reduces prints in ZydisFuzzIn"
    OFF)
option(ZYDIS_LIBFUZZER
    "Enables LLVM libfuzzer mode and reduces prints in ZydisFuzzIn"
    OFF)

# Dependencies
option(ZYAN_SYSTEM_ZYCORE
    "Force using system installed Zycore library"
    OFF)
set(ZYAN_ZYCORE_PATH
    "${CMAKE_CURRENT_LIST_DIR}/dependencies/zycore"
    CACHE
    PATH
    "The path to look for Zycore")

# =============================================================================================== #
# Dependencies                                                                                    #
# =============================================================================================== #

# Tries to make Zycore available.
#
# Priorities:
#
# - ZYAN_ZYCORE_PATH specified path always takes maximum precedence if it exists.
#   - Default value is the sub-module path. So if the sub-module is present, we pick that.
#     Allows hacking on Zydis/Zycore even if a Zydis OS package is installed.
# - Look for a system-installed Zycore package (via find_package).
# - If git is installed & this is a git repository, try cloning the sub-module.
# - Give up.
#
# This is in a function so we can elegantly early-exit once the library is found.
function (locate_zycore)
    if (NOT ${ZYAN_SYSTEM_ZYCORE} AND EXISTS "${ZYAN_ZYCORE_PATH}/CMakeLists.txt")
        message(VERBOSE "Using ZYAN_ZYCORE_PATH specified Zycore")
        add_subdirectory(${ZYAN_ZYCORE_PATH} "zycore" EXCLUDE_FROM_ALL)
        return ()
    endif ()

    if (NOT "${ZYAN_ZYCORE_PATH}" STREQUAL "${CMAKE_CURRENT_LIST_DIR}/dependencies/zycore")
        message(FATAL_ERROR "No CMake project found at explicitly set ZYAN_ZYCORE_PATH")
    endif ()

    find_package(Zycore QUIET)
    if (Zycore_FOUND)
        message(VERBOSE "Using system Zycore")
        return ()
    endif ()

    if (ZYAN_SYSTEM_ZYCORE)
        message(FATAL_ERROR "ZYAN_SYSTEM_ZYCORE set but no system-installed Zycore found")
    endif ()

    find_package(Git QUIET)
    if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
        message(VERBOSE "Pulling Zycore submodule with git.")
        execute_process(
                COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
        add_subdirectory(${ZYAN_ZYCORE_PATH} "zycore" EXCLUDE_FROM_ALL)
        return ()
    endif()

    message(
        FATAL_ERROR
        "Can't find Zycore. Please make sure to clone the repo recursively.\n"
        "You can fix this by running\n"
        "    git submodule update --init\n"
        "or by cloning using\n"
        "    git clone --recursive <url>\n"
        "Alternatively, you can manually clone zycore to some path and set ZYDIS_ZYCORE_PATH."
    )
endfunction ()

locate_zycore()

# =============================================================================================== #
# Library configuration                                                                           #
# =============================================================================================== #

if (ZYDIS_BUILD_SHARED_LIB)
    add_library("Zydis" SHARED)
else ()
    add_library("Zydis" STATIC)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_STATIC_BUILD")
endif ()

target_link_libraries("Zydis" PUBLIC "Zycore")
target_include_directories("Zydis"
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    PRIVATE "src")
target_compile_definitions("Zydis" PRIVATE "_CRT_SECURE_NO_WARNINGS")
set_target_properties("Zydis" PROPERTIES
    VERSION "${Zydis_VERSION}"
    SOVERSION "${Zydis_VERSION_MAJOR}.${Zydis_VERSION_MINOR}"
    DEFINE_SYMBOL "ZYDIS_SHOULD_EXPORT")
zyan_set_common_flags("Zydis")
zyan_maybe_enable_wpo("Zydis")

if (ZYDIS_FEATURE_FORMATTER AND NOT ZYDIS_FEATURE_DECODER)
    message(
        FATAL_ERROR
        "\nZYDIS_FEATURE_FORMATTER requires ZYDIS_FEATURE_DECODER to be enabled"
    )
endif ()

if (ZYDIS_FEATURE_ENCODER AND (ZYDIS_MINIMAL_MODE OR
                               NOT ZYDIS_FEATURE_DECODER OR
                               NOT ZYDIS_FEATURE_AVX512 OR
                               NOT ZYDIS_FEATURE_KNC))
    message(
        FATAL_ERROR
        "\nZYDIS_FEATURE_ENCODER requires ZYDIS_FEATURE_DECODER in full mode (ZYDIS_MINIMAL_MODE \
        disabled) with all ISA extensions (ZYDIS_FEATURE_AVX512 and ZYDIS_FEATURE_KNC enabled)"
    )
endif ()

if (ZYDIS_MINIMAL_MODE)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_MINIMAL_MODE")
endif ()
if (NOT ZYDIS_FEATURE_DECODER)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_DECODER")
endif ()
if (NOT ZYDIS_FEATURE_ENCODER)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_ENCODER")
endif ()
if (NOT ZYDIS_FEATURE_FORMATTER)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_FORMATTER")
endif ()
if (NOT ZYDIS_FEATURE_AVX512)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_AVX512")
endif ()
if (NOT ZYDIS_FEATURE_KNC)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_KNC")
endif ()
if (NOT ZYDIS_FEATURE_SEGMENT)
    target_compile_definitions("Zydis" PUBLIC "ZYDIS_DISABLE_SEGMENT")
endif ()

target_sources("Zydis"
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Defines.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/MetaInfo.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Mnemonic.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Register.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Segment.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/SharedTypes.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/ShortString.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Status.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Utils.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Zydis.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/SharedData.h"
        "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/String.h"
        "src/MetaInfo.c"
        "src/Mnemonic.c"
        "src/Register.c"
        "src/Segment.c"
        "src/SharedData.c"
        "src/String.c"
        "src/Utils.c"
        "src/Zydis.c")

if (ZYDIS_FEATURE_DECODER)
    target_sources("Zydis"
        PRIVATE
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Decoder.h"
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/DecoderTypes.h"
            "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/DecoderData.h"
            "src/Decoder.c"
            "src/DecoderData.c")
    if (ZYDIS_FEATURE_ENCODER)
        target_sources("Zydis"
            PRIVATE
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Encoder.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/EncoderData.h"
                "src/Encoder.c"
                "src/EncoderData.c")
    endif ()
    if (ZYDIS_FEATURE_FORMATTER AND (NOT ZYDIS_MINIMAL_MODE))
        target_sources("Zydis"
            PRIVATE
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Disassembler.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Formatter.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/FormatterBuffer.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterATT.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterBase.h"
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Internal/FormatterIntel.h"
                "src/Disassembler.c"
                "src/Formatter.c"
                "src/FormatterBuffer.c"
                "src/FormatterATT.c"
                "src/FormatterBase.c"
                "src/FormatterIntel.c")
    endif ()
    if (ZYDIS_FEATURE_SEGMENT)
        target_sources("Zydis"
            PRIVATE
                "${CMAKE_CURRENT_LIST_DIR}/include/Zydis/Segment.h"
                "src/Segment.c")
    endif ()
endif ()

if (ZYDIS_BUILD_SHARED_LIB AND WIN32)
    target_sources("Zydis" PRIVATE "resources/VersionInfo.rc")
endif ()

zyan_set_source_group("Zydis")

configure_package_config_file(cmake/zydis-config.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis"
)
write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config-version.cmake"
    COMPATIBILITY SameMajorVersion
)
install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/zydis-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis"
)

install(TARGETS "Zydis"
    EXPORT "zydis-targets"
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(EXPORT "zydis-targets"
    NAMESPACE "Zydis::"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/zydis")
install(DIRECTORY "include/" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

function (_maybe_set_emscripten_cfg target)
    if (EMSCRIPTEN)
        # Yep, that madness below is how Emscripten likes its quotes.
        set_target_properties("${target}"
            PROPERTIES COMPILE_FLAGS
            "-s \"EXPORT_NAME='${target}'\" -s MODULARIZE=1")
        set_target_properties("${target}"
            PROPERTIES LINK_FLAGS_RELEASE
            "-s \"EXPORT_NAME='${target}'\" -s MODULARIZE=1")
    endif ()
endfunction ()

function(_add_example target source_file sub_folder)
    add_executable("${target}" "examples/${source_file}")
    target_link_libraries("${target}" "Zydis")
    set_target_properties("${target}" PROPERTIES FOLDER "Examples/${sub_folder}")
    target_compile_definitions("${target}" PRIVATE "_CRT_SECURE_NO_WARNINGS")
    zyan_set_common_flags("${target}")
    zyan_maybe_enable_wpo("${target}")
    _maybe_set_emscripten_cfg("${target}")
endfunction()

# =============================================================================================== #

=== meson_options.txt ===
option(
  'minimal',
  type: 'feature',
  value: 'disabled',
  description: 'Enable minimal mode (forces ZYDIS_DECODER_MODE_MINIMAL runtime option)',
)
option(
  'decoder',
  type: 'feature',
  value: 'auto',
  description: 'Enable instruction decoding functionality',
)
option(
  'encoder',
  type: 'feature',
  value: 'auto',
  description: 'Enable instruction encoding functionality',
)
option(
  'formatter',
  type: 'feature',
  value: 'auto',
  description: 'Enable instruction formatting functionality',
)
option(
  'avx512',
  type: 'feature',
  value: 'auto',
  description: 'Enable support for AVX-512 instructions',
)
option(
  'knc',
  type: 'feature',
  value: 'auto',
  description: 'Enable support for KNC instructions',
)
option(
  'segment',
  type: 'feature',
  value: 'auto',
  description: 'Enable instruction segment API',
)

option(
  'examples',
  type: 'feature',
  value: 'auto',
  description: 'Build examples',
)
option(
  'tools',
  type: 'feature',
  value: 'auto',
  description: 'Build tools',
)
option(
  'man',
  type: 'feature',
  value: 'auto',
  description: 'Build manpages for the tools (requires Ronn-NG)',
)
option(
  'doc',
  type: 'feature',
  value: 'auto',
  description: 'Build doxygen documentation (requires Doxygen)',
)
option(
  'tests',
  type: 'feature',
  value: 'auto',
  description: 'Build tests',
)

option(
  'nolibc',
  type: 'boolean',
  value: false,
  description: 'Do not use any C standard library functions (for exotic build-envs like kernel drivers)',
)

option(
  'llvm-fuzz',
  type: 'boolean',
  value: false,
  description: 'Enables LLVM libfuzzer mode and reduces prints in ZydisFuzzIn',
)

=== debian/changelog ===
zydis (4.1.1-3) unstable; urgency=medium

  * Retry tag2upload push (see bug #1112106)

 -- Andrea Pappacoda <tachi@debian.org>  Thu, 04 Sep 2025 17:57:47 +0200

zydis (4.1.1-2) unstable; urgency=medium

  * d/rules: make ZYDIS_BUILD_TESTS conditional on nocheck (Closes: #1112085)
  * d/upstream/metadata: add Archive: GitHub
  * d/watch: convert to version 5

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 26 Aug 2025 10:27:17 +0200

zydis (4.1.1-1) unstable; urgency=low

  * New upstream version 4.1.1
  * d/control: apply X-Style black
  * d/control: declare dpkg-build-api = 1
  * d/control: use my @debian.org email address
  * d/rules: build with CMake
  * d/README.source: document packaging worflow

 -- Andrea Pappacoda <tachi@debian.org>  Sun, 06 Apr 2025 23:43:18 +0200

=== debian/control ===
Source: zydis
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <tachi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
 dpkg-dev (>= 1.22.5),
Build-Depends-Arch:
 cmake,
 libzycore-dev (>= 1.5.0),
 python3 <!nocheck>,
 ronn,
Build-Depends-Indep:
 cmake,
 doxygen <!nodoc>,
 doxygen-awesome-css <!nodoc>,
 graphviz <!nodoc>,
 libzycore-dev (>= 1.5.0),
 python3 <!nocheck>,
 ronn,
Standards-Version: 4.7.2
Homepage: https://zydis.re
Vcs-Git: https://salsa.debian.org/debian/zydis.git
Vcs-Browser: https://salsa.debian.org/debian/zydis
X-Style: black

Package: libzydis4.1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: fast and lightweight x86/x86-64 disassembler library
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the shared library.

Package: libzydis-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libzycore-dev (>= 1.0.0-2),
 libzydis4.1 (= ${binary:Version}),
 ${misc:Depends},
Description: fast and lightweight x86/x86-64 disassembler library - development
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the development files.

Package: libzydis-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: fast and lightweight x86/x86-64 disassembler library - documentation
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the generated Doxygen documentation.

Package: zydis-tools
Section: devel
Architecture: any
Multi-Arch: foreign
Depends:
 libzydis4.1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: fast and lightweight x86/x86-64 disassembler library - tools
 Zydis is a fast x86/x86-64 disassembler library. It supports all x86 and
 AMD64 instructions and many vendor extensions, doesn't perform dynamic
 memory allocations, is thread safe by design and has no third party
 dependency - not even libc.
 .
 This package contains the command line tools.

=== debian/rules ===
#!/usr/bin/make -f

# optimize=-lto because I use CMake's LTO
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto qa=+all

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  test := true
else
  test := false
endif

%:
	dh $@ --builddir=build --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
		-DCMAKE_POLICY_DEFAULT_CMP0069=NEW \
		-DBUILD_SHARED_LIBS=ON \
		-DZYDIS_BUILD_SHARED_LIB=ON \
		-DZYDIS_BUILD_EXAMPLES=OFF \
		-DZYDIS_BUILD_TOOLS=ON \
		-DZYAN_SYSTEM_ZYCORE=ON \
		-DZYDIS_BUILD_MAN=ON \
		-DZYDIS_BUILD_TESTS=$(test) \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

override_dh_installdocs-indep:
	dh_installdocs --indep --doc-main-package=libzydis-doc

override_dh_installexamples-indep:
	dh_installexamples --indep --doc-main-package=libzydis-doc

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_installdocs-indep:
	dh_doxygen --indep
endif

=== debian/watch ===
Version: 5

Template: GitHub
Owner: zyantific
Project: zydis
Uversion-Mangle: s/-rc/~rc/
